> ## Documentation Index
> Fetch the complete documentation index at: https://ona.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# List Prompts

> Lists all prompts matching the specified criteria.

`Unary` · [`Agents`](/docs/api-reference/generated/agent/overview)

Lists all prompts matching the specified criteria.

Use this method to find and browse prompts across your organization.
Results are ordered by their creation time with the newest first.

### Examples

* List all prompts:

  Retrieves all prompts with pagination.

  ```yaml theme={null}
  pagination:
    pageSize: 10
  ```

## Endpoint

```text theme={null}
POST /api/gitpod.v1.AgentService/ListPrompts
```

Send a Bearer token as described in [Authentication](/docs/api-reference#authenticate-requests). If your organization uses a custom management-plane domain, replace `https://app.ona.com` with that domain.

## Request example

<CodeGroup>
  ```bash cURL theme={null}
  export ONA_HOST=https://app.ona.com
  export ONA_API_KEY=<your-token>

  curl --request POST \
    --url "$ONA_HOST/api/gitpod.v1.AgentService/ListPrompts" \
    --header "Authorization: Bearer $ONA_API_KEY" \
    --header "Content-Type: application/json" \
    --data '{
    "pagination": {
      "pageSize": 1
    }
  }'
  ```

  ```python Python theme={null}
  import gitpod.v1.agent_pb2 as agent_pb2
  import gitpod.v1.pagination_pb2 as pagination_pb2
  from ona_sdk import create_client_from_env

  ona = create_client_from_env()
  request = agent_pb2.ListPromptsRequest(
      pagination=pagination_pb2.PaginationRequest(
          page_size=1,
      ),
  )
  response = ona.services.agent.list_prompts(request)
  print(response)
  ```

  ```typescript TypeScript theme={null}
  import { create } from "@bufbuild/protobuf";
  import { createClientFromEnv } from "@gitpod/sdk";
  import { ListPromptsRequestSchema } from "@gitpod/sdk/gitpod/v1/agent_pb";

  async function main() {
    const ona = createClientFromEnv();
    const request = create(ListPromptsRequestSchema, {
      pagination: {
        pageSize: 1,
      },
    });
    const response = await ona.services.agent.listPrompts(request);
    console.log(response);
  }

  main().catch(console.error);
  ```

  ```go Go theme={null}
  package main

  import (
  	"context"
  	"fmt"
  	"log"

  	"connectrpc.com/connect"
  	"github.com/gitpod-io/gitpod-sdk-go/sdk"
  	gitpodpb "github.com/gitpod-io/gitpod-sdk-go/v1"
  )

  func main() {
  	ona, err := sdk.NewFromEnv()
  	if err != nil {
  		log.Fatal(err)
  	}

  	request := connect.NewRequest(&gitpodpb.ListPromptsRequest{
  		Pagination: &gitpodpb.PaginationRequest{
  			PageSize: 1,
  		},
  	})
  	response, err := ona.Services.Agent.ListPrompts(context.Background(), request)
  	if err != nil {
  		log.Fatal(err)
  	}
  	fmt.Println(response.Msg)
  }
  ```

  ```json Request body theme={null}
  {
    "pagination": {
      "pageSize": 1
    }
  }
  ```
</CodeGroup>

## Request

`gitpod.v1.ListPromptsRequest`

| Field        | Type                                                    | Required | Description |
| ------------ | ------------------------------------------------------- | -------- | ----------- |
| `pagination` | [PaginationRequest](#type-gitpod-v1-pagination-request) | No       |             |
| `filter`     | [Filter](#type-gitpod-v1-list-prompts-request-filter)   | No       |             |

## Response

`gitpod.v1.ListPromptsResponse`

| Field        | Type                                                      | Required | Description |
| ------------ | --------------------------------------------------------- | -------- | ----------- |
| `pagination` | [PaginationResponse](#type-gitpod-v1-pagination-response) | No       |             |
| `prompts`    | array of [Prompt](#type-gitpod-v1-prompt)                 | No       |             |

## Related types

<a id="type-gitpod-v1-list-prompts-request-filter" />

<Accordion title="Filter">
  `gitpod.v1.ListPromptsRequest.Filter`

  | Field                  | Type    | Required | Description                                                                                                                                                                                                                       |
  | ---------------------- | ------- | -------- | --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
  | `isTemplate`           | boolean | No       |                                                                                                                                                                                                                                   |
  | `isCommand`            | boolean | No       |                                                                                                                                                                                                                                   |
  | `command`              | string  | No       |                                                                                                                                                                                                                                   |
  | `commandPrefix`        | string  | No       | Constraints: `string.max_len=50`.                                                                                                                                                                                                 |
  | `isSkill`              | boolean | No       |                                                                                                                                                                                                                                   |
  | `excludePromptContent` | boolean | No       | exclude\_prompt\_content omits the large spec.prompt text from the response. Other spec fields (is\_template, is\_command, command, is\_skill) are still returned. Use GetPrompt to retrieve the full prompt content when needed. |
  | `search`               | string  | No       | search performs case-insensitive search across prompt name, description, and command. Constraints: `string.max_len=256`.                                                                                                          |
</Accordion>

<a id="type-gitpod-v1-pagination-request" />

<Accordion title="PaginationRequest">
  `gitpod.v1.PaginationRequest`

  | Field      | Type    | Required | Description                                                                                                                              |
  | ---------- | ------- | -------- | ---------------------------------------------------------------------------------------------------------------------------------------- |
  | `pageSize` | integer | No       | Page size is the maximum number of results to retrieve per page. Defaults to 25. Maximum 100. Constraints: `int32.gte=0, int32.lte=100`. |
  | `token`    | string  | No       | Token for the next set of results that was returned as next\_token of a PaginationResponse                                               |
</Accordion>

<a id="type-gitpod-v1-pagination-response" />

<Accordion title="PaginationResponse">
  `gitpod.v1.PaginationResponse`

  | Field       | Type   | Required | Description                                                                             |
  | ----------- | ------ | -------- | --------------------------------------------------------------------------------------- |
  | `nextToken` | string | No       | Token passed for retrieving the next set of results. Empty if there are no more results |
</Accordion>

<a id="type-gitpod-v1-prompt" />

<Accordion title="Prompt">
  `gitpod.v1.Prompt`

  | Field      | Type                                              | Required | Description |
  | ---------- | ------------------------------------------------- | -------- | ----------- |
  | `id`       | string                                            | No       |             |
  | `metadata` | [PromptMetadata](#type-gitpod-v1-prompt-metadata) | No       |             |
  | `spec`     | [PromptSpec](#type-gitpod-v1-prompt-spec)         | No       |             |
</Accordion>

<a id="type-gitpod-v1-prompt-metadata" />

<Accordion title="PromptMetadata">
  `gitpod.v1.PromptMetadata`

  | Field            | Type               | Required | Description                                                                                              |
  | ---------------- | ------------------ | -------- | -------------------------------------------------------------------------------------------------------- |
  | `organizationId` | string             | No       | organization\_id is the ID of the organization that contains the prompt Constraints: `string.uuid=true`. |
  | `name`           | string             | No       | name is the human readable name of the prompt                                                            |
  | `description`    | string             | No       | description is a description of what the prompt does                                                     |
  | `creator`        | Subject            | No       | creator is the identity of the prompt creator                                                            |
  | `createdAt`      | RFC 3339 timestamp | No       |                                                                                                          |
  | `updatedAt`      | RFC 3339 timestamp | No       |                                                                                                          |
</Accordion>

<a id="type-gitpod-v1-prompt-spec" />

<Accordion title="PromptSpec">
  `gitpod.v1.PromptSpec`

  | Field        | Type    | Required | Description                                                                                                                     |
  | ------------ | ------- | -------- | ------------------------------------------------------------------------------------------------------------------------------- |
  | `prompt`     | string  | No       | prompt is the content of the prompt Constraints: `string.max_len=20000`.                                                        |
  | `isTemplate` | boolean | No       | is\_template indicates if this prompt is a template                                                                             |
  | `isCommand`  | boolean | No       | is\_command indicates if this prompt is a command                                                                               |
  | `command`    | string  | No       | command is the unique command string within the organization Constraints: `string.max_len=50, string.pattern=^[a-zA-Z0-9_-]*$`. |
  | `isSkill`    | boolean | No       | is\_skill indicates if this prompt is a skill (workflow instructions for agents)                                                |
</Accordion>
